-- $Id: bwaa-queue.adb 59 2009-04-05 10:37:07Z georg $
---------------------------------------------------------------------------
--                                                                       --
--                   BWAA - Busy Wait Analyser for Ada                   --
--      BWAA is a program that finds busy waiting in Ada programs.       --
--                          http://cfg.w3x.org                           --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
--                 Copyright (c) 2009 Georg Kienesberger                 --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
-- This file is part of BWAA.                                            --
--                                                                       --
-- BWAA is free software; you can redistribute it and/or modify          --
-- it under the terms of the GNU General Public License as published by  --
-- the Free Software Foundation; either version 3 of the License, or     --
-- (at your option) any later version.                                   --
--                                                                       --
-- BWAA is distributed in the hope that it will be useful,               --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of        --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         --
-- GNU General Public License for more details.                          --
--                                                                       --
-- You should have received a copy of the GNU General Public License     --
-- along with this program.  If not, see <http://www.gnu.org/licenses/>. --
--                                                                       --
---------------------------------------------------------------------------

package body Bwaa.Queue is

   procedure Put (Q: in out Object; I: in Item) is
   begin
      Append(Q.List, I);
   end Put;

   procedure Get (Q: in out Object; I: out Item) is
   begin

      if Is_Empty(Q.List) then
         raise Queue_Exception with "Empty queue.";
      end if;

      I := First_Element(Q.List);
      Delete_First(Q.List);
   end Get;

   function Is_Empty (Q: in Object) return Boolean is
   begin
      return Is_Empty(Q.List);
   end Is_Empty;

end Bwaa.Queue;
