-- $Id: bwaa-queue.ads 59 2009-04-05 10:37:07Z georg $
---------------------------------------------------------------------------
--                                                                       --
--                   BWAA - Busy Wait Analyser for Ada                   --
--      BWAA is a program that finds busy waiting in Ada programs.       --
--                          http://cfg.w3x.org                           --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
--                 Copyright (c) 2009 Georg Kienesberger                 --
--                                                                       --
---------------------------------------------------------------------------
--                                                                       --
-- This file is part of BWAA.                                            --
--                                                                       --
-- BWAA is free software; you can redistribute it and/or modify          --
-- it under the terms of the GNU General Public License as published by  --
-- the Free Software Foundation; either version 3 of the License, or     --
-- (at your option) any later version.                                   --
--                                                                       --
-- BWAA is distributed in the hope that it will be useful,               --
-- but WITHOUT ANY WARRANTY; without even the implied warranty of        --
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         --
-- GNU General Public License for more details.                          --
--                                                                       --
-- You should have received a copy of the GNU General Public License     --
-- along with this program.  If not, see <http://www.gnu.org/licenses/>. --
--                                                                       --
---------------------------------------------------------------------------

with Ada.Containers.Doubly_Linked_Lists;

generic
   type Item is private;
   with function "=" (Left,Right: Item) return Boolean is <>;
package Bwaa.Queue is

   type Object is private;

   procedure Put (Q: in out Object; I: in Item);
   procedure Get (Q: in out Object; I: out Item);
   function Is_Empty (Q: in Object) return Boolean;

   Queue_Exception: exception;

private
   package Lists is new Ada.Containers.Doubly_Linked_Lists(Element_Type => Item, "=" => "=");
   use Lists;

   type Object is
      record
         List: Lists.List;
      end record;
end Bwaa.Queue;
